/* Unhide yjesus@security-projects.com */

#include <stdio.h>
#include <string.h>
#include <sys/stat.h>
#include <unistd.h>
#include <sys/resource.h>
#include <errno.h>
#include <dirent.h>
#include <sched.h>
#include <sys/types.h>
#include <signal.h>
#include <stdlib.h>
#include <sys/sysinfo.h>
#include <fcntl.h>


#define COMMAND "ps -eL o lwp"
#define SESSION "ps -eL o sess"
#define PGID "ps -eL o pgid="
#define THREADS "ps -eL o lwp"


// sysctl kernel.pid_max
int maxpid= 32768;

void get_max_pid(int* newmaxpid) {
      char path[]= "/proc/sys/kernel/pid_max";
      pid_t tmppid = 0;
      FILE* fd= fopen(path,"r");
      if(!fd) {
	printf("[*] Error: cannot get current maximum PID: %s\n", strerror(errno));
	return;
      }


      if((fscanf(fd, "%d", &tmppid) != 1) ||
	 tmppid < 1) {
	printf("[*] cannot get current maximum PID: Error parsing %s format\n", path);
	return;
      } else {
	*newmaxpid = tmppid;
      }
}

int checkps(int tmppid, int morechecks) {
	
	int ok = 0;
	char pids[30];
	char sessionpids[30] ;
	char pgidpids[30] ;
	
	char compare[100];
	char comparesession[100];
	char comparepgid[100];
	
	
	FILE *fich_tmp ;
	
	fich_tmp=popen (COMMAND, "r") ;
	
	
	while (!feof(fich_tmp) && ok == 0) {
		char* tmp_pids = pids;

		fgets(pids, 30, fich_tmp);
		pids[29] = 0;

		while( *tmp_pids == ' ' && tmp_pids <= pids+30) {
			tmp_pids++;
		}

		sprintf(compare,"%i\n",tmppid);
		
		if (strncmp(tmp_pids, compare, 30) == 0) {ok = 1;}
		
		
        }
	
	pclose(fich_tmp);
	
	FILE *fich_thread ;
	
	fich_thread=popen (THREADS, "r") ;
	
	
	while (!feof(fich_thread) && ok == 0) {
		char* tmp_pids = pids;

		fgets(pids, 30, fich_thread);
		pids[29] = 0;

		while( *tmp_pids == ' ' && tmp_pids <= pids+30) {
			tmp_pids++;
		}

		sprintf(compare,"%i\n",tmppid);
		
		if (strncmp(tmp_pids, compare, 30) == 0) {ok = 1;}
		
		
        }
	
	
	pclose(fich_thread);
	
	if (morechecks == 1) {
	
		FILE *fich_session ;
	
		fich_session=popen (SESSION, "r") ;
	
		
		while (!feof(fich_session) && ok == 0) {
			char* tmp_pids = pids;

			fgets(pids, 30, fich_tmp);
			pids[29] = 0;

			while( *tmp_pids == ' ' && tmp_pids <= pids+30) {
				tmp_pids++;
			}

			sprintf(compare,"%i\n",tmppid);
		
			if (strncmp(tmp_pids, compare, 30) == 0) {ok = 1;}
		
		}
		
		pclose(fich_session);
		
		
		FILE *fich_pgid ;
	
		fich_pgid=popen (PGID, "r") ;
	
		
		while (!feof(fich_pgid) && ok == 0) {
			char* tmp_pids = pids;

			fgets(pids, 30, fich_tmp);
			pids[29] = 0;

			while( *tmp_pids == ' ' && tmp_pids <= pids+30) {
				tmp_pids++;
			}

			sprintf(compare,"%i\n",tmppid);
		
			if (strncmp(tmp_pids, compare, 30) == 0) {ok = 1;}
		
		}
		
		pclose(fich_pgid);
		
	}
	return ok;	
}

void printbadpid (int tmppid) {

		
	int faked ;
	int statuscmd ;
	char cmd[100] ;
		
	

	struct stat buffer;
			
	printf ("Found HIDDEN PID: %i\n", tmppid) ;
	
    
	sprintf(cmd,"/proc/%i/cmdline",tmppid);
		
	statuscmd = stat(cmd, &buffer);
		
	if (statuscmd == 0) {
			
		FILE *cmdfile ;
		char cmdcont[1000];
			
		cmdfile=fopen (cmd, "r") ;
			
			
		while (!feof (cmdfile)) {
				
		
			fgets (cmdcont, 1000, cmdfile);
			printf ("Command: %s\n\n", cmdcont);
				
		}
	}	
}		


void checkproc() {
	
	int procpids ;
	int statusprocbefore, statusprocafter;
	struct stat buffer;
	
	printf ("[*]Searching for Hidden processes through /proc scanning\n\n") ;
		
	for ( procpids = 1; procpids <= maxpid; procpids = procpids +1 ) {
		
		char directory[100] ;
		
		
		sprintf(directory,"/proc/%d",procpids);
		
		
		statusprocbefore = stat(directory, &buffer) ;
		if (statusprocbefore != 0) {
		  continue;
		}

		if(checkps(procpids,0)) {
		  continue;
		}

		statusprocafter = stat(directory, &buffer) ;		
		if (statusprocafter != 0) {
		  continue;
		}

		printbadpid(procpids);
	}
}

void checkgetpriority() {
	
	int syspids ;
	
	printf ("[*]Searching for Hidden processes through getpriority() scanning\n\n") ;
	
	
	for ( syspids = 1; syspids <= maxpid; syspids = syspids +1 ) {
		
		int which = PRIO_PROCESS;
		
		int ret;
		
		errno= 0 ;
		
		ret = getpriority(which, syspids);
		if ( errno != 0) {
		  continue;
		}

		if(checkps(syspids,0)) {
		  continue;
		}

		errno=0;
		ret = getpriority(which, syspids);
		if ( errno != 0) {
		  continue;
		}

		printbadpid(syspids);
		
	}
}
		
void checkgetpgid() {
	
	int syspids ;
	
	
	printf ("[*]Searching for Hidden processes through getpgid() scanning\n\n") ;
	
	
	
	for ( syspids = 1; syspids <= maxpid; syspids = syspids +1 ) {
		
		int ret;
		
		errno= 0 ;
		
		ret = getpgid(syspids);
		if ( errno != 0 ) {
		  continue;
		}

		if(checkps(syspids,0)) {
		  continue;
		}

		errno=0;
		ret = getpgid(syspids);
		if ( errno != 0 ) {
		  continue;
		}

		printbadpid(syspids);
	}
}		
		

void checkgetsid() {
	
	int syspids ;
	
	
	printf ("[*]Searching for Hidden processes through getsid() scanning\n\n") ;
	
	
	for ( syspids = 1; syspids <= maxpid; syspids = syspids +1 ) {
		
		int ret;
		
		errno= 0 ;
		
		ret = getsid(syspids);
		if ( errno != 0) {
		  continue;
		}
		if(checkps(syspids,0)) {
		  continue;
		}
		errno=0;
		ret = getsid(syspids);
		if ( errno != 0) {
		  continue;
		}

		printbadpid(syspids);
		
	}
}		


void checksched_getaffinity() {
	
	int syspids;
	cpu_set_t mask;
	
	printf ("[*]Searching for Hidden processes through sched_getaffinity() scanning\n\n") ;
	
	
	for ( syspids = 1; syspids <= maxpid; syspids = syspids +1 ) {
		
		int ret;
		
		errno= 0 ;
		
		ret = sched_getaffinity(syspids, sizeof(cpu_set_t), &mask);
		if (errno != 0) {
		  continue;
		}
		if (checkps(syspids,0)) {
		  continue;
		}
		errno=0;
		ret = sched_getaffinity(syspids, sizeof(cpu_set_t), &mask);
		if (errno != 0) {
		  continue;
		}

		printbadpid(syspids);
	}
}		


void checksched_getparam() {
	
	int syspids;
	struct sched_param param;
	
	printf ("[*]Searching for Hidden processes through sched_getparam() scanning\n\n") ;
	
	
	for ( syspids = 1; syspids <= maxpid; syspids = syspids +1 ) {
		
		int ret;
		
		errno= 0 ;
		
		ret = sched_getparam(syspids, &param);
		if ( errno != 0) {
		  continue;
		}

		if(checkps(syspids,0)) {
		  continue;
		}

		errno=0;
		ret = sched_getparam(syspids, &param);
		if ( errno != 0) {
		  continue;
		}

		printbadpid(syspids);
		
	}
}		

void checksched_getscheduler() {
	
	int syspids ;
	
	
	printf ("[*]Searching for Hidden processes through sched_getscheduler() scanning\n\n") ;
	
	
	for ( syspids = 1; syspids <= maxpid; syspids = syspids +1 ) {
		
		int ret;
		
		errno= 0 ;
		
		ret = sched_getscheduler(syspids);
		if ( errno != 0) {
		  continue;
		}

		if(checkps(syspids,0)) {
		  continue;
		}

		errno=0;
		ret = sched_getscheduler(syspids);
		if ( errno != 0) {
		  continue;
		}

		printbadpid(syspids);
		
	}
}		

void checksched_rr_get_interval() {
	
	int syspids;
	struct timespec tp;
	
	printf ("[*]Searching for Hidden processes through sched_rr_get_interval() scanning\n\n") ;
	
	
	for ( syspids = 1; syspids <= maxpid; syspids = syspids +1 ) {
		
		int ret;
		
		errno= 0 ;
		
		ret = sched_rr_get_interval(syspids, &tp);
		if ( errno != 0) {
		  continue;
		}

		if(checkps(syspids,0)) {
		  continue;
		}

		errno=0;
		ret = sched_rr_get_interval(syspids, &tp);
		if ( errno != 0) {
		  continue;
		}

		printbadpid(syspids);
	}
}

void checkkill() {
	
	int syspids;
	
	printf ("[*]Searching for Hidden processes through kill(..,0) scanning\n\n") ;
	
	
	for ( syspids = 1; syspids <= maxpid; syspids = syspids +1 ) {
		
		int ret;
		
		errno= 0 ;
		ret = kill(syspids, 0);
		if ( errno != 0) {
			continue;
		}
		
		if(checkps(syspids,0)) {
			continue;
		}

		errno= 0 ;
		ret = kill(syspids, 0);
		if ( errno != 0) {
			continue;
		}

		printbadpid(syspids);
	}
}

void checkallnoprocps() {

	/* compare the various system calls against each other,
	 * without invoking 'ps' or looking at /proc */

	int ret;
	int syspids;
	struct timespec tp;
	struct sched_param param;
	cpu_set_t mask;
	int found=0;
	int found_killbefore=0;
	int found_killafter=0;

	for ( syspids = 1; syspids <= maxpid; syspids++ ) {

		found=0;
		found_killbefore=0;
		found_killafter=0;

		errno=0; 
		ret = kill(syspids, 0);
		if (errno == 0) found_killbefore=1;

		errno= 0 ;
		ret = getpriority(PRIO_PROCESS, syspids);
		if (errno == 0) found++;

		errno= 0 ;
		ret = getpgid(syspids);
		if (errno == 0) found++;

		errno= 0 ;
		ret = getsid(syspids);
		if (errno == 0) found++;

		errno= 0 ;
		ret = sched_getaffinity(syspids, sizeof(cpu_set_t), &mask);
		if (ret == 0) found++;

		errno= 0 ;
		ret = sched_getparam(syspids, &param);
		if (errno == 0) found++;

		errno= 0 ;
		ret = sched_getscheduler(syspids);
		if (errno == 0) found++;

		errno=0; 
		ret = sched_rr_get_interval(syspids, &tp);
		if (errno == 0) found++;

		errno=0; 
		ret = kill(syspids, 0);
		if (errno == 0) found_killafter=1;


		/* these should all agree, except if a process went or came in the middle */
		if (found_killbefore == found_killafter) {
			if ( ! ((found_killbefore == 0 && found == 0) ||
			        (found_killbefore == 1 && found == 7)) ) {
				printf ("Found HIDDEN PID: %i\n", syspids) ;
			}
		} /* else: unreliable */
	}
}

void checksysinfo() {
	
	struct sysinfo info;
	int contador=0;
	int resultado_antes=0;
	int resultado_despues=0;
	int ocultos=0;
	char buffer[500];

	FILE *fich_proceso ;
	
	printf ("[*]Searching for Hidden processes through sysinfo() scanning\n\n") ;
	

	sysinfo(&info);
	resultado_antes=info.procs;

	fich_proceso=popen (COMMAND, "r") ;
	
	
	while (!feof(fich_proceso)) {
		
		fscanf( fich_proceso, "%s", &buffer );	
		contador++;
		
        }
	
	pclose(fich_proceso);
	
	sysinfo(&info);
	resultado_despues=info.procs;

	if (resultado_antes == resultado_despues) {  /* otherwise intermittent activity.. */

		ocultos=resultado_despues - contador +3;
	
		if (ocultos != 0) {
		
			printf("HIDDEN Processes Found:%i\n",abs(ocultos)) ;

		}
	}

}


void brute() {
	
	int i=0;
	int vpid;
	int allpids[maxpid] ;
	int x;
	int y;
	int z;
	
	
	printf ("[*]Starting scanning using brute force against PIDS\n\n") ;
	
	for(x=0; x < 299; x++) {
		
		allpids[x] = '\0' ;
	}
	
	
	for(z=300; z < maxpid; z++) {
		
		allpids[z] = z ;
	}
	
	
	for (i=0; i < maxpid; i++) {
		
		errno= 0 ;
		
		if (vfork() == 0) { 
			
			vpid = getpid();
			
			allpids[vpid] =  '\0';
			
			//exit(1);
			_exit(2) ;
		}
		
		waitpid(vpid);
		
	}
	
	for(y=0; y < maxpid; y++) {
		
		if (allpids[y] != '\0') {
			
			if(!checkps(allpids[y],1) ) {

				printbadpid(allpids[y]);

		  	}

		}
		
	}	
	
			
	
	
}




int main (int argc, char *argv[]) {
	
	
	printf ("Unhide 20090810 \n") ;
	printf ("http://www.security-projects.com/?Unhide\n\n\n") ;
	get_max_pid(&maxpid);
	
	if(argc != 2) {
		
		printf("usage: %s proc | sys | brute\n\n", argv[0]);
		exit (1);
		
	} 
	
	setpriority(PRIO_PROCESS,0,-20);  /* reduce risk from intermittent processes - may fail, dont care */

	if (strcmp(argv[1], "proc") == 0) {checkproc();}
	
	else if (strcmp(argv[1], "sys") == 0) {
		checkkill();
		checkallnoprocps();
		checkgetpriority();
		checkgetpgid() ;
		checkgetsid();
		checksched_getaffinity();
		checksched_getparam();
		checksched_getscheduler();
		checksched_rr_get_interval();
		checksysinfo();
		
	}
	
	else if(strcmp(argv[1], "brute") == 0) {
		
		brute();
		
	}
	
	
}
